Subject: Re: [Announce] GIT v1.5.0-rc2

From: Jakub Narebski <[email-masked]>
Date: Mon, 22 Jan 2007 00:08:48 +0100

Johannes Schindelin wrote:

> On Sun, 21 Jan 2007, Jakub Narebski wrote:
> 
>> Johannes Schindelin wrote:
>> 
>>> On Sun, 21 Jan 2007, Junio C Hamano wrote:
>> 
>>>> * Reflog
>>>> 
>>>>  - Reflog records the history of where the tip of each branch
>>>>    was at each moment.
>>> 
>>> It might make sense to reformulate that:
>>> 
>>>       Reflog records the history from the view point of the local 
>>>       repository. In other words, regardless of the real history,
>>>       the reflog shows the history as seen by one particular repository
>>>       (this enables you to ask "what was the current revision in _this_
>>>       repository, yesterday at 1pm?").
>> 
>> I think that _both_ sentences are right. Reflog records history of where the
>> tip of each branch was at each moment, logging also what command was used
>> to move tip of branch (was it commit, amending commit, rebase, reset, or
>> creating branch anew, git-am or pull).
>> 
>> But where tip of each branch was is purely local matter. What is global
>> is DAG of commits, refs are always as seen by one particular repository.
> 
> What I meant was: people not familiar with git development will probably 
> not understand the shorter, concise statement. They will not know off-hand 
> that there is a difference between the history of development, and the 
> history, as seen from the local repository's viewpoint.
> 
> So of course, both sentences are right.
> 
> Your point -- that reflog also records the action -- is less important 
> IMHO. It is just meta-data of the local view.
> 
> To your second point: the global history remains global, of course. But 
> this is what you _usually_ refer to, when talking about the development 
> history, anyway. Therefore, to motivate reflogs, you should point out the 
> differences between local and global history.
> 
> And this means to at least _mention_ the word "local".

So I'd say:

  - Reflog records local history of where the tip of each branch
    was at each moment.

I think both "local" and "tip of branch" are important
for understanding reflog.

-- 
Jakub Narebski
Poland